 //

#define ENABLESERIALDEBUG
#ifdef ENABLESERIALDEBUG
  #define _PRT(S) Serial.print(S);
  #define _PRTN(S) Serial.println(S);
  #define _PRTF(S) Serial.print(F(S));
  #define _PRTFN(S) Serial.println(F(S));
#endif

// 20khz/200p
//#define NPWM  200
//#define PPWM  900     

//25khz/250p
//#define NPWM  250 
//#define PPWM  960

//32khz/320p
#define NPWM  320
#define PPWM  749



uint8_t uf,oen,v1low, lv_stopped,int_f;
uint16_t pcount;
uint32_t vpwr;
int sst;
uint16_t l[NPWM+1];
float pwr;
uint8_t dbounce;
double Input, Output, Setpoint;
double errSum, lastErr,error,dErr;
double kp, ki, kd;
float xv[5],yv[5],sm_pca;
float ac_output, ac_setpoint;

void init_vars(void);

int pcount_acc,new_delta_int;
int pcount_delta, phase_error, old_phase_error;
int pcint,new_delta, p_lock, sdcount=0;
int p_lock_count = 0;

uint8_t init_done; 
uint8_t tt=0;

volatile int tc;
volatile int pe_frac;


volatile int _pcorrect;
volatile boolean _spflag3a = false;
volatile uint32_t tickstimer3 = 0;
volatile uint32_t tim3tick = 0;
uint32_t _freqint = 0;
float _pwmres = 0;

volatile uint32_t t0 = 0;
volatile uint32_t dt = 0;
volatile boolean t0flg = false;
volatile boolean t1flg = false;



void setup()
{

  #ifdef ENABLESERIALDEBUG
    Serial.begin(115200);     // remove in prodduction code
  #endif
  delay(2000);

  int i;
  float t,u; 
  for(t=0.0,i=0; i <= NPWM; i++,t +=   3.14159/ (float) (NPWM+1))
  {   
    u = 65500.0 * (0.98*sin(t));   // 1/2 wave sine lookup table, scaled to (16 bits - a small amount)
    l[i] =  (int)u;  
    //     _PRT("index:") _PRT(i)
    //     _PRT(" | t:") _PRT(t)
    //     _PRT(" | NPWM:") Serial.print(NPWM);
    //     _PRT(" | l[i]:") Serial.println(l[i]); 
  }


  //SETTING PIN REGISTER
  //pinMode(LED_BUILTIN, OUTPUT);
  RCC->APB2ENR |= RCC_APB2ENR_IOPCEN;                    // enable clock portc
  GPIOC->CRH &= ~(GPIO_CRH_MODE13 | GPIO_CRH_CNF13);     // reset PC13 speed and mode
  GPIOC->CRH |= (GPIO_CRH_MODE13_1 | GPIO_CRH_MODE13_0); // speed 2mhz  push-pull


  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN | RCC_APB2ENR_AFIOEN;  // enable clock portb and alternate functions
  
  // PB0 INPUT  sync pin
  //pinMode(PB0, INPUT);
  GPIOB->CRL &= ~(GPIO_CRL_MODE0 | GPIO_CRL_CNF0);     // reset PB0 speed and mode
  GPIOB->CRL |= GPIO_CRL_CNF0_1; // input floating
  
  // PB14 OUTPUT
  GPIOB->CRH &= ~(GPIO_CRH_MODE14 | GPIO_CRH_CNF14);     // reset PB14 speed and mode
  GPIOB->CRH |= GPIO_CRH_MODE14_1; // speed 2mhz  push-pull
  GPIOB->ODR |= GPIO_ODR_ODR14; // PB14 off


  RCC->APB2ENR |= RCC_APB2ENR_IOPAEN | RCC_APB2ENR_AFIOEN;      // enable clock portb

  // use only V1 con complete fullwave like Peter sketch 
  // PA06  drive V1
  GPIOA->CRL &= ~(GPIO_CRL_MODE6 | GPIO_CRL_CNF6);     // reset PA6 speed and mode
  GPIOA->CRL |= GPIO_CRL_MODE6_1 | GPIO_CRL_CNF6_1; // speed 2mhz  push-pull
  GPIOA->ODR |= GPIO_ODR_ODR6; // PA06 off  
  // PA07 drive V2
  GPIOA->CRL &= ~(GPIO_CRL_MODE7 | GPIO_CRL_CNF7);     // reset PA6 speed and mode
  GPIOA->CRL |= GPIO_CRL_MODE7_1 | GPIO_CRL_CNF7_1; // speed 2mhz  push-pull
  GPIOA->ODR |= GPIO_ODR_ODR7; // PA07 off    


  oen = 0;        // output enable. = 1 to run inverter, = 0 to stop inverter
  init_vars();
  p_lock = 0;          // phase lock flag = 0 = NOT locked
  pcount_acc = 0;      // fractional integer math. Each PWM, pcount_delta is added to pcount_acc and divided by 1024
  pcount_delta = 1024; // in effect we are getting an addition of 1. But pcount_delta can be modified, a little bigger or smaller..
  old_phase_error = 0; // used in PID, to obtain derivative
  init_done = 1;
  
 
  //SETTING TIM3 REGISTER
  __disable_irq(); /* Disable interrupts */  
  TIM3->CR1 &= ~TIM_CR1_CEN;         // disable timer  
  RCC->APB1RSTR |= (RCC_APB1RSTR_TIM3RST);         // Reset the TIM block
  RCC->APB1RSTR &= ~(RCC_APB1RSTR_TIM3RST);        // Reset the TIM block   
  RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;          // enable clock for TIM
  
  TIM3->SMCR  = 0x0000;                        // Slave mode disabled   
  TIM3->CCER |= TIM_CCER_CC1P; // polarity
  TIM3->CCER |= TIM_CCER_CC1E; // Capture/Compare Enable Register  
  TIM3->CCMR1 = 0; // reset register
  TIM3->CCMR1 |= TIM_CCMR1_OC1PE; // Output compare 1 preload enable
  TIM3->CCMR1 |= (0<<1) | (0<<0); // Capture/Compare 1 selection 00 CC1 channel is configured as output.  
  TIM3->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1; // OC1M output compare mode PWM mode 1

  // Fpwm = Fclk / (ARR+1)x(PSC+1)  Npoint = Fpwm/50hz/2
  TIM3->SR = 0;            // status register clear the timer1 flags   
  TIM3->PSC = 2;           // prescaler
  TIM3->ARR = PPWM;        // 
  TIM3->DIER |= TIM_DIER_UIE; // enable timer2 update interrupt

  //https://deepbluembedded.com/convert-pwm-to-a-dac-using-pwm-to-generate-analog-waveforms/
  _freqint = F_CPU / (TIM3->ARR + 1) / (TIM3->PSC + 1);
  _PRT("SETTING PWM FREQ: ") _PRT(_freqint) _PRTN("hz")

  _pwmres = log(F_CPU/_freqint) / log(2);
  _PRT("PWM RESOLUTION: ") _PRT(_pwmres) _PRTN("bits")
   
  TIM3->CR1 &= ~TIM_CR1_CMS; // reset center aligned mode  
  TIM3->CR1 = (0<<6) | (0<<5); // TIM_CR1_CMS 00: Edge-aligned mode
  TIM3->CR1 &= ~TIM_CR1_DIR; // reset direction counter
  TIM3->CR1 |= (0<<4);         // 0: Counter used as upcounter
  TIM3->CR1 |= TIM_CR1_CEN;         // counter enable
 
  NVIC_ClearPendingIRQ(TIM3_IRQn);
  NVIC_SetPriorityGrouping(0);
  NVIC_SetPriority(TIM3_IRQn, 0);
  NVIC_EnableIRQ(TIM3_IRQn);

  //SETTING EXTI REGISTER
  // https://wae2vnawou2vs2nenrqfcbgd5q--www-rotr-info.translate.goog/electronics/mcu/stm32f100/stm32_exti.htm
  EXTI->IMR |=  (1 << 0);    // 0001: pin del microcontrollore PB [x]; Setup the button's EXTI line as an interrupt.
//  EXTI->RTSR &= ~(1 << 0);    // Disable the 'rising edge' trigger (button release).
//  EXTI->FTSR |=  (1 << 0);    // Enable the 'falling edge' trigger (button press). 

  EXTI->FTSR &= ~(1 << 0);      // Disable the 'falling edge' trigger (button press). 
  EXTI->RTSR |=  (1 << 0);      // Enable the 'rising edge' trigger (button release).
  AFIO->EXTICR[0] |= (1 << 0);  //PB0 pin sync

  NVIC_SetPriority(EXTI0_IRQn, 1); // // Enable the NVIC interrupt for EXTI0 and EXTI1 at minimum priority.
  NVIC_EnableIRQ(EXTI0_IRQn);
 
  __enable_irq() ;   
    
  _PRTN("ENTERING VOID LOOP")
} //end setup()


extern "C" void TIM3_IRQHandler(void)
{ 
  TIM3->SR &=~TIM_SR_UIF;       // clear UIF flag 

  if(t0flg)
  {
    t0 = micros();
    t0flg = false;
  }
  
  long c;
  int i;
  //
  // alter the 20kHz PWM rate in accordance with PLL loop correction
  // if pcount_delta = 0 then no change needed
  // so this is the amount needed to steer the output back into phase lock
  // It is not the error of lock, it is the amount needed to change from 20kHz
  //
  i = pcount_delta/256;  
  TIM3->ARR = PPWM - i;
  pcount_delta = (pcount_delta - 256 * i) + pcount_acc + 135;  // 135 is trim for the 16MHz clock is not quite 16.0000
  
  // look up PWM duty for this part of the 1/2 cycle 
  c = (l[pcount] * vpwr) >> 16;   // scale sine wave by vpwr, 32 bit integer calcs. 16 bit shift fastest of all
       
//  if (v1low == 1){                 // drive only this pin
//    //TIM3->CCR1 = PPWM/2 + c;                   
//  }
//  else 
//  {
//    //TIM3->CCR1 = PPWM/2 - c;
//  } 
  TIM3->CCR1 = PPWM/2 + (v1low == 1?c:-c);  
  
  // just go to next duty % lookup, 0 to 199 inclusive (compare with previous code)
  pcount++;     
  
  if(pcount >= NPWM)          // pcount  will = NPWM, at each 1/2 wave, at the start
  {
    pcount = 0;               // reset counter
    uf=1;                     // enable one PID control loop execution, in loop()
    
    if (v1low == 1)           // if first 1/2 wave..
    {      
      v1low = 0;             // toggle to 2nd half wave
                                // int_f = 1 enables INT0 to execute, which sets int_f = 0 if run. If not run, it remains = 1
      if (int_f == 1)          // no AC sync signal at all, pull sync lock output LOW. 
      {                       
        //cbi(PORTD,4);         // tell world, no sync
        //sbi(PORTB,3);       // led red pin11 
        GPIOB->ODR |= GPIO_ODR_ODR14; //led sync off
        pcount_delta = 0;   // after sync loss, also when/if no sync lock ever attained, ensure AC output is 50Hz
        p_lock = 0;
      }
      int_f = 1;               // this is here, last to execute, to ensure this PWM code runs first and is not delayed by
       
    } // subsequent AC sync interrupt processing. 
        
    else
    {
     v1low = 1;             // toggle to 1st half wave     
    }
  } // if(pcount >= NPWM)


  
  tickstimer3++;
  
  //delayMicroseconds(10);         // test for isr timing
  if(t1flg)
  {
    dt = micros() - t0;
    t1flg = false;
  }
   
  if(++tim3tick > _freqint) // 1second delay
  { 
    _spflag3a = true;       // serial print flag
    tim3tick = 0;  
    GPIOC->ODR ^= GPIO_ODR_ODR13;  // on board led
    t0flg = true;
    t1flg = true;
  }  
  
} //end extern "C" void TIM3_IRQHandler(void)


extern "C" void EXTI0_IRQHandler(void)
{   
  if (EXTI->PR & (1 << 0)) // Check that EXTI1 (or 0?) is the line that triggered.    
  { 
    EXTI->PR |= (1 << 0); // If it was, clear the interrupt flag. //PB0
  }

    int bd = 500;
//  int tc;
//  int pe_frac=0;
  pe_frac=0;   
  //tc = TCNT1;
  tc = TIM3->CNT;
  
  if  (int_f == 0) 
    return;  // only once per 50 Hz cycle. Noise! much noise...
  int_f = 0;

// best tracking accuracy yet. need integral term now due to different feedback
// into 20kHz timer clock
//
  pe_frac = (32 * tc)/PPWM;
  pcount_acc = 0;
  //phase_error = 32*(pcount - 32 +  (v1low == 1?NPWM:0) - NPWM) + pe_frac; 
  phase_error = ( 32*(pcount - 32 +  (v1low == 1?NPWM:0) - NPWM - _pcorrect) + pe_frac);                                                                                  
       
  new_delta = 2 * phase_error ;
  new_delta_int += new_delta;
  pcount_acc = -new_delta - new_delta_int/4 ;
  
  if (abs(phase_error) < 50)
  {
    p_lock = 1; 
    p_lock_count++;
    GPIOB->ODR &= ~GPIO_ODR_ODR14; //led sync on            
  }
  else
  {    
    p_lock=0;
    p_lock_count = 0;
    GPIOB->ODR |= GPIO_ODR_ODR14; //led sync off
  }

} //end extern "C" void EXTI15_10_IRQHandler(void)


void init_vars()      // called prior to setting oen = 1, as well as from setup()
{
  TIM3->ARR = PPWM;  
  pcount_acc=0;
  lv_stopped = 0;  
  sst = 0;      // slow start counter 0 - 251
  v1low = 1;    // half wave output flag, 0 or 1
  pcount = 0;   // counter for sine wave lookup table
  uf = 0;       // set to 1 to enable AC output voltage feedback code to execute
  pwr = 0.0;    // PWM duty cycle analog, 0.0 to 1.0
  vpwr= 0;      // integer equivalent of pwr, 0 to PPWM
  dbounce = 0;  // debounce counter for input switch 
  kp = 0.1;     // set up PID for AC output voltage control
  ki = 0.0;
  kd = 0.01;
  errSum = 0.0;        // initialise PID
  lastErr = 0.0;
  int_f = 0;           //used in AC sync, one shot per 50Hz
  if (p_lock == 1)
  {
   // nothing to do so far 
  }
  else
  { 
    p_lock = 0;          // phase lock flag = 0 = NOT locked
    pcount_delta = 0; // in effect we are getting an addition of 1. But pcount_delta can be modified, a little bigger or smaller..
    old_phase_error = 0; // used in PID, to obtain derivative
  }
  //cbi(PORTD,4);  
} //end init_vars()


void do_pid()
{   
  double timeChange = 0.01;    // always called at 100Hz, so dT will be 10msec..
  error = Setpoint - Input;
  errSum += (error * timeChange);
  dErr = (error - lastErr) / timeChange;
  Output = kp * error + ki * errSum + kd * dErr;
  lastErr = error;
} //end do_pid()


void loop()
{  
  float spwr;  

  //_pcorrect = map(analogRead(A1), 0, 1023, -200, 200);
  _pcorrect = 10; 
   
  if( p_lock_count >= 100)
  {
    _PRTN("SWITCH RELE")
    p_lock_count = 0;
  }
  
  // sample channel..
  // In the past, I low pass filtered this. not now, no need thanks to active LP filter on Vfb
  //ac_output = (float)analogRead(A0) / 1024.0; // scale 0 - 5V to 0.0 to 1.0
  ac_output = 0.99; 
    
  if(uf == 1 )    // this will execute at 100Hz
  {            // it runs at near zero volt crossing of AC output       
    uf=0;     

    if (oen == 1) sst++;      // slow start. If output is enabled, keep starting up. sst = output pwm% or approx. voltage.
    if (sst > 251)sst = 251;  // stop increasing when sst has got to the end of slow start. when = 251, this enables PID. See below..
    if (oen == 0) sst--;      // if stopping, slow stop
    
    if (sst <= 0)             // once fully stopped, no more changes to sst needed
    {
      sst = 0;        
    }  

    // obtain variac drive power level from potentiometer, on ADC port a0    
    pwr = pwr * 0.9 + 0.1 * ac_output; // scale 0 - 5V to 0.0 to 1.0 and low pass it with shitty but simple filter
    if(sst >= 0 && sst <= 250)         // slow start timer counts to 250 with gentle ramp up, then switches over to direct pwm drive from analog port
    {                           // sst can increase or decrease, giving the slow start and slow stop.
      spwr = (float)sst/250.0;
    }
    else
      spwr = 1.0;  
    pwr = pwr * spwr;
      
    if (pwr > 0.99) pwr = 0.99;     // clamp. Do math in floating point to prevent any integer overflow
    if (pwr < 0.01) pwr = 0.01;     // it's slower. We could do clamp after conversion to int but it's your mosfets...
    vpwr = (int)((float)(PPWM/2) * pwr);// finally apply required PWM duty power factor to vpwr     
    check_switch_cont(); 
  }


  #ifdef ENABLESERIALDEBUG
  if (_spflag3a){    
    if(oen) _PRT("ON") else _PRT("OFF")  

    _PRT(" | FrqPWM:") _PRT(tickstimer3) tickstimer3 = 0; 

    _PRT(" | TIM3->CCR1:") _PRT(TIM3->CCR1) 
        
    _PRT(" | pcrt:") _PRT(_pcorrect) _PRT(" | pe:") _PRT(phase_error)

    _PRT(" | dt:") _PRT(dt)
    
    _PRT(" | sync:")
    if(p_lock && oen) _PRT("ok") else _PRT("ko")  
    
    _PRTN("")    
    _spflag3a = false;  
  } //end if(_spflag3a)
  #endif  
  
} //end loop()


void check_switch_cont()
{   // called at 100 Hz
 
//  if ((PINB & 0x01) == 0x01)     
//  {
    if (init_done == 0)
    {
      init_vars();
      init_done = 1;
    }  
    oen = 1;      // slow start
//    sbi(PORTB,4); // and light LED on D12, pin 15 of nano
//  }

  // scr shutdown - without a dummy connection of D6 to ground, inverter wont run.
//  if (((PINB & 0x01) == 0) || ((PIND & 0x40) == 0x40)) 
//  // for testing, do not check scr shutdown pin, just nano2 on/off
//  //if (((PINB & 0x01) == 0) )       
//  {
//    init_done = 0;
//    oen = 0;    // slow stop
//    cbi(PORTB,4); // and blank LED on D12, pin 15 of nano
//  }
          
} //end check_switch_cont()


// EOF //
